Package icyllis.arc3d.engine

# Class OpsRenderPass

java.lang.Object
icyllis.arc3d.engine.OpsRenderPass

Direct Known Subclasses:
  `GLOpsRenderPass`

@Deprecated public abstract class OpsRenderPass extends Object
Deprecated.
The `OpsRenderPass` is a series of commands (draws, clears, and discards), which all target the same render target. `Ops` execute into a `OpsRenderPass`.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected GpuRenderTarget`
  `mRenderTarget`
  Deprecated.
  `protected int`
  `mSurfaceOrigin`
  Deprecated.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `OpsRenderPass()`
  Deprecated.
  `OpsRenderPass(GpuRenderTarget fs, int origin)`
  Deprecated.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `begin()`
  Deprecated.
  `final void`
  `bindBuffers(@RawPtr Buffer indexBuffer, int indexType, @RawPtr Buffer vertexBuffer, int vertexStreamOffset, @RawPtr Buffer instanceBuffer, int instanceStreamOffset)`
  Deprecated.
  Binds geometric (input) buffers to current command buffer.
  `void`
  `bindPipeline(GraphicsPipelineDesc_Old graphicsPipelineDesc, GraphicsPipeline pipeline, Rect2fc drawBounds)`
  Deprecated.
  Updates the internal pipeline state for drawing.
  `final void`
  `bindTexture(@RawPtr ImageViewProxy geomTexture)`
  Deprecated.
  Single texture version of `bindTextures(ImageViewProxy[])`.
  `final void`
  `bindTextures(@RawPtr ImageViewProxy[] geomTextures)`
  Deprecated.
  Binds textures for the geometry processor.
  `void`
  `clearColor(int left, int top, int right, int bottom, float red, float green, float blue, float alpha)`
  Deprecated.
  Clear the owned render target.
  `void`
  `clearStencil(int left, int top, int right, int bottom, boolean insideMask)`
  Deprecated.
  Same as `clearColor(int, int, int, int, float, float, float, float)` but modifies the stencil.
  `final void`
  `draw(int vertexCount, int baseVertex)`
  Deprecated.
  Records a non-indexed draw to current command buffer.
  `final void`
  `drawIndexed(int indexCount, int baseIndex, int baseVertex)`
  Deprecated.
  Records an indexed draw to current command buffer.
  `final void`
  `drawIndexedInstanced(int indexCount, int baseIndex, int instanceCount, int baseInstance, int baseVertex)`
  Deprecated.
  Records an indexed draw to current command buffer.
  `final void`
  `drawInstanced(int instanceCount, int baseInstance, int vertexCount, int baseVertex)`
  Deprecated.
  Records a non-indexed draw to current command buffer.
  `void`
  `end()`
  Deprecated.
  `protected abstract Device`
  `getDevice()`
  Deprecated.
  `protected abstract void`
  `onBindBuffers(@SharedPtr Buffer indexBuffer, int indexType, @SharedPtr Buffer vertexBuffer, int vertexStreamOffset, @SharedPtr Buffer instanceBuffer, int instanceStreamOffset)`
  Deprecated.
  `protected abstract boolean`
  `onBindPipeline(GraphicsPipelineDesc_Old graphicsPipelineDesc, GraphicsPipeline pipeline, Rect2fc drawBounds)`
  Deprecated.
  `protected abstract void`
  `onDraw(int vertexCount, int baseVertex)`
  Deprecated.
  `protected abstract void`
  `onDrawIndexed(int indexCount, int baseIndex, int baseVertex)`
  Deprecated.
  `protected abstract void`
  `onDrawIndexedInstanced(int indexCount, int baseIndex, int instanceCount, int baseInstance, int baseVertex)`
  Deprecated.
  `protected abstract void`
  `onDrawInstanced(int instanceCount, int baseInstance, int vertexCount, int baseVertex)`
  Deprecated.
  `protected void`
  `set(GpuRenderTarget renderTarget, int origin)`
  Deprecated.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### mRenderTarget

    protected GpuRenderTarget mRenderTarget
    Deprecated.

  - ### mSurfaceOrigin

    protected int mSurfaceOrigin
    Deprecated.

- ## Constructor Details

  - ### OpsRenderPass

    public OpsRenderPass()
    Deprecated.

  - ### OpsRenderPass

    public OpsRenderPass(GpuRenderTarget fs, int origin)
    Deprecated.

- ## Method Details

  - ### begin

    public void begin()
    Deprecated.

  - ### end

    public void end()
    Deprecated.

  - ### clearColor

    public void clearColor(int left, int top, int right, int bottom, float red, float green, float blue, float alpha)
    Deprecated.
    Clear the owned render target. Clears the full target if 'scissor' is disabled, otherwise it is restricted to 'scissor'.

  - ### clearStencil

    public void clearStencil(int left, int top, int right, int bottom, boolean insideMask)
    Deprecated.
    Same as `clearColor(int, int, int, int, float, float, float, float)` but modifies the stencil.

  - ### bindPipeline

    public void bindPipeline(GraphicsPipelineDesc_Old graphicsPipelineDesc, GraphicsPipeline pipeline, Rect2fc drawBounds)
    Deprecated.
    Updates the internal pipeline state for drawing. Enters an internal "bad" state if the pipeline could not be set.
    Parameters:
      `graphicsPipelineDesc` - the pipeline info used to update uniforms
      `pipeline` - the pipeline state object
      `drawBounds` - the sub-area of render target for subsequent draw calls

  - ### bindTexture

    public final void bindTexture(@RawPtr @RawPtr ImageViewProxy geomTexture)
    Deprecated.
    Single texture version of `bindTextures(ImageViewProxy[])`.
    Parameters:
      `geomTexture` - the raw ptr to textures at binding 0

  - ### bindTextures

    public final void bindTextures(@RawPtr @RawPtr ImageViewProxy[] geomTextures)
    Deprecated.
    Binds textures for the geometry processor. Texture bindings are dynamic state and therefore not set during `bindPipeline(icyllis.arc3d.engine.trash.GraphicsPipelineDesc_Old, icyllis.arc3d.engine.GraphicsPipeline, icyllis.arc3d.core.Rect2fc)`. If the current program uses textures, then the client must call this method before drawing. The geometry processor textures may also be updated between draws by calling this method again with a different array for textures.

    Note that this method is only used for GP using texture. If GP does not use texture but FP does, they will be automatically set during `bindPipeline(icyllis.arc3d.engine.trash.GraphicsPipelineDesc_Old, icyllis.arc3d.engine.GraphicsPipeline, icyllis.arc3d.core.Rect2fc)`, and this is a no-op. Otherwise, this method must be called if the GP uses textures.

    Parameters:
      `geomTextures` - the raw ptr to textures starting from binding 0

  - ### bindBuffers

    public final void bindBuffers(@RawPtr @RawPtr Buffer indexBuffer, int indexType, @RawPtr @RawPtr Buffer vertexBuffer, int vertexStreamOffset, @RawPtr @RawPtr Buffer instanceBuffer, int instanceStreamOffset)
    Deprecated.
    Binds geometric (input) buffers to current command buffer.
    Parameters:
      `indexBuffer` - raw ptr to the index buffer if using indexed rendering, or nullptr
      `indexType` - index type, see `Engine.IndexType`
      `vertexBuffer` - raw ptr to the vertex buffer, can be nullptr
      `vertexStreamOffset` - byte offset to first vertex of vertex stream
      `instanceBuffer` - raw ptr to the instance buffer if using instanced rendering, or nullptr
      `instanceStreamOffset` - byte offset to first instance of instance stream

  - ### draw

    public final void draw(int vertexCount, int baseVertex)
    Deprecated.
    Records a non-indexed draw to current command buffer.
    Parameters:
      `vertexCount` - the number of vertices to draw
      `baseVertex` - the index of the first vertex to draw

  - ### drawIndexed

    public final void drawIndexed(int indexCount, int baseIndex, int baseVertex)
    Deprecated.
    Records an indexed draw to current command buffer.
    Parameters:
      `indexCount` - the number of vertices to draw
      `baseIndex` - the base index within the index buffer
      `baseVertex` - the value added to the vertex index before indexing into the vertex buffer

  - ### drawInstanced

    public final void drawInstanced(int instanceCount, int baseInstance, int vertexCount, int baseVertex)
    Deprecated.
    Records a non-indexed draw to current command buffer.
    Parameters:
      `instanceCount` - the number of instances to draw
      `baseInstance` - the instance ID of the first instance to draw
      `vertexCount` - the number of vertices to draw
      `baseVertex` - the index of the first vertex to draw

  - ### drawIndexedInstanced

    public final void drawIndexedInstanced(int indexCount, int baseIndex, int instanceCount, int baseInstance, int baseVertex)
    Deprecated.
    Records an indexed draw to current command buffer.
    Parameters:
      `indexCount` - the number of vertices to draw
      `baseIndex` - the base index within the index buffer
      `instanceCount` - the number of instances to draw
      `baseInstance` - the instance ID of the first instance to draw
      `baseVertex` - the value added to the vertex index before indexing into the vertex buffer

  - ### set

    protected void set(GpuRenderTarget renderTarget, int origin)
    Deprecated.

  - ### getDevice

    protected abstract Device getDevice()
    Deprecated.

  - ### onBindPipeline

    protected abstract boolean onBindPipeline(GraphicsPipelineDesc_Old graphicsPipelineDesc, GraphicsPipeline pipeline, Rect2fc drawBounds)
    Deprecated.

  - ### onBindBuffers

    protected abstract void onBindBuffers(@SharedPtr @SharedPtr Buffer indexBuffer, int indexType, @SharedPtr @SharedPtr Buffer vertexBuffer, int vertexStreamOffset, @SharedPtr @SharedPtr Buffer instanceBuffer, int instanceStreamOffset)
    Deprecated.

  - ### onDraw

    protected abstract void onDraw(int vertexCount, int baseVertex)
    Deprecated.

  - ### onDrawIndexed

    protected abstract void onDrawIndexed(int indexCount, int baseIndex, int baseVertex)
    Deprecated.

  - ### onDrawInstanced

    protected abstract void onDrawInstanced(int instanceCount, int baseInstance, int vertexCount, int baseVertex)
    Deprecated.

  - ### onDrawIndexedInstanced

    protected abstract void onDrawIndexedInstanced(int indexCount, int baseIndex, int instanceCount, int baseInstance, int baseVertex)
    Deprecated.